SystemOrganization addCategory: #'IRDA2013-sorting2-SorterClasses'!

Object subclass: #S2AbstractFocusedIndicesEvaluator
	instanceVariableNames: 'listPartSorter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2AbstractFocusedIndicesEvaluator class methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 14:37:17.436'!
newWithListPartSorter: aListPartSorter
|me|
	me := self new.
	me listPartSorter: aListPartSorter.
	^me.! !

!S2AbstractFocusedIndicesEvaluator methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 16:30:26.057'!
compareElement: left withElement: right withPivot: pivot
	^self subclassResponsibility.! !

!S2AbstractFocusedIndicesEvaluator methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 20:13:56.326'!
compareFocusedElementsInList: list
	^self compareElement: (list firstFocusedElement)
		withElement: (list secondFocusedElement) 
		withPivot: list pivotElement.! !

!S2AbstractFocusedIndicesEvaluator methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 16:07:35.371'!
evaluateFocusedElements
|list|
	list := self listPartSorter sorter list.
	(self compareFocusedElementsInList: list) ifTrue: [
		self switchFocusedElementsInList: list.
	].! !

!S2AbstractFocusedIndicesEvaluator methodsFor: 'accessing' stamp: 'AT 6/16/2013 14:37:26.988'!
listPartSorter

	^ listPartSorter! !

!S2AbstractFocusedIndicesEvaluator methodsFor: 'accessing' stamp: 'AT 6/16/2013 14:37:27.012'!
listPartSorter: anObject

	listPartSorter := anObject! !

!S2AbstractFocusedIndicesEvaluator methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 19:06:12.29'!
switchFocusedElementsInList: list
	list switchElementAt: (list firstFocusedIndex)
		withElementAt: (list secondFocusedIndex).! !

S2AbstractFocusedIndicesEvaluator subclass: #S2BubblesortFocusedIndicesEvaluator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2BubblesortFocusedIndicesEvaluator methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 00:27:38.247'!
compareElement: left withElement: right withPivot: pivot
	^left > right! !

S2AbstractFocusedIndicesEvaluator subclass: #S2QuicksortFocusedIndicesEvaluator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2QuicksortFocusedIndicesEvaluator methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 19:38:34.672'!
compareElement: left withElement: right withPivot: pivot
	^(left > pivot) and: (right < pivot).! !

Object subclass: #S2AbstractFocusedIndicesFinder
	instanceVariableNames: 'listPartSorter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2AbstractFocusedIndicesFinder class methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 14:36:29.473'!
newWithListPartSorter: aListPartSorter
|me|
	me := self new.
	me listPartSorter: aListPartSorter.
	^me.! !

!S2AbstractFocusedIndicesFinder methodsFor: 'focussing' stamp: 'AT 6/16/2013 19:49:14.213'!
initFirstFocusedIndexWithLeftBound: left withRightBound: right
	^self subclassResponsibility.! !

!S2AbstractFocusedIndicesFinder methodsFor: 'focussing' stamp: 'AT 6/16/2013 19:50:46.025'!
initPivotIndexWithLeftBound: left withRightBound: right
	^self subclassResponsibility! !

!S2AbstractFocusedIndicesFinder methodsFor: 'focussing' stamp: 'AT 6/16/2013 19:49:19.965'!
initSecondFocusedIndexWithLeftBound: left withRightBound: right
	^self subclassResponsibility.! !

!S2AbstractFocusedIndicesFinder methodsFor: 'focussing' stamp: 'AT 6/16/2013 19:49:59.431'!
initializeFocusedIndicesInList: list
	list updateFirstFocusedIndex: (self initFirstFocusedIndexWithLeftBound: (list leftBoundIndex) withRightBound: (list rightBoundIndex)).
	list updateSecondFocusedIndex: (self initSecondFocusedIndexWithLeftBound: (list leftBoundIndex) withRightBound: (list rightBoundIndex)).
	list updatePivotIndex: (self initPivotIndexWithLeftBound: (list leftBoundIndex) withRightBound: (list rightBoundIndex)).! !

!S2AbstractFocusedIndicesFinder methodsFor: 'accessing' stamp: 'AT 6/16/2013 14:36:50.511'!
listPartSorter

	^ listPartSorter! !

!S2AbstractFocusedIndicesFinder methodsFor: 'accessing' stamp: 'AT 6/16/2013 14:36:50.527'!
listPartSorter: anObject

	listPartSorter := anObject! !

!S2AbstractFocusedIndicesFinder methodsFor: 'subclass responsibility' stamp: 'AT 6/16/2013 16:36:49.389'!
nextFirstFocusedIndex: currentIndex
	^self subclassResponsibility.! !

!S2AbstractFocusedIndicesFinder methodsFor: 'focussing' stamp: 'AT 6/16/2013 19:46:04.663'!
nextFocusedElementsIndicesInList: list
|firstUpdate secondUpdate|
	(list firstFocusedIndex isNil or: (list secondFocusedIndex isNil)) ifTrue: [
		self initializeFocusedIndicesInList: list].
	firstUpdate := self shouldUpdateFirst: (list firstFocusedElement) withPivot: (list pivotElement).
	secondUpdate := self shouldUpdateSecond: (list secondFocusedElement) withPivot: (list pivotElement).
	firstUpdate ifTrue: [
		list updateFirstFocusedIndex: (self nextFirstFocusedIndex: list firstFocusedIndex)].
	(secondUpdate and: (self updateBothFocusesAtOnce or: firstUpdate not)) ifTrue: [
		list updateSecondFocusedIndex: (self nextSecondFocusedIndex: (list secondFocusedIndex)).].! !

!S2AbstractFocusedIndicesFinder methodsFor: 'subclass responsibility' stamp: 'AT 6/16/2013 16:36:44.61'!
nextSecondFocusedIndex: currentIndex
	^self subclassResponsibility.! !

!S2AbstractFocusedIndicesFinder methodsFor: 'subclass responsibility' stamp: 'AT 6/16/2013 16:44:45.362'!
shouldUpdateFirst: element withPivot: pivot
	^self subclassResponsibility.! !

!S2AbstractFocusedIndicesFinder methodsFor: 'subclass responsibility' stamp: 'AT 6/16/2013 16:45:01.75'!
shouldUpdateSecond: element withPivot: pivot
	^self subclassResponsibility.! !

!S2AbstractFocusedIndicesFinder methodsFor: 'subclass responsibility' stamp: 'AT 6/16/2013 16:41:34.243'!
updateBothFocusesAtOnce
	^self subclassResponsibility.! !

!S2AbstractFocusedIndicesFinder methodsFor: 'focussing' stamp: 'AT 6/17/2013 10:42:31.843'!
updateFocusedElementsIndices
|list i j|
	list := self listPartSorter sorter list.
	(list firstFocusedIndex isNil or: (list secondFocusedIndex isNil)) 
		ifTrue: [self initializeFocusedIndicesInList: list.]
		ifFalse: [i := list firstFocusedIndex.
			j := list secondFocusedIndex.
			self nextFocusedElementsIndicesInList: self listPartSorter sorter list.
			"The focus should change each time. If not, something went wrong."
			(i = list firstFocusedIndex and: (j = list secondFocusedIndex)) ifTrue: [
				self error: 'I got stuck'.].].! !

S2AbstractFocusedIndicesFinder subclass: #S2BubblesortFocusedIndicesFinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2BubblesortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 00:24:40.601'!
initFirstFocusedIndexWithLeftBound: left withRightBound: right
	^left! !

!S2BubblesortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 00:26:06.555'!
initPivotIndexWithLeftBound: left withRightBound: right
	^nil! !

!S2BubblesortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 00:25:36.577'!
initSecondFocusedIndexWithLeftBound: left withRightBound: right
	^left+1! !

!S2BubblesortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 09:26:46.612'!
nextFirstFocusedIndex: currentIndex
	^currentIndex + 1! !

!S2BubblesortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 09:26:51.211'!
nextSecondFocusedIndex: currentIndex
	^currentIndex + 1! !

!S2BubblesortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 00:26:57.329'!
shouldUpdateFirst: element withPivot: pivot
	^true! !

!S2BubblesortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 00:27:07.838'!
shouldUpdateSecond: element withPivot: pivot
	^true! !

!S2BubblesortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 00:27:16.293'!
updateBothFocusesAtOnce
	^true! !

S2AbstractFocusedIndicesFinder subclass: #S2QuicksortFocusedIndicesFinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2QuicksortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 19:48:54.023'!
initFirstFocusedIndexWithLeftBound: left withRightBound: right
	^left! !

!S2QuicksortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 19:50:25.257'!
initPivotIndexWithLeftBound: left withRightBound: right
	^right! !

!S2QuicksortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 20:14:55.278'!
initSecondFocusedIndexWithLeftBound: left withRightBound: right
	(right > left) ifTrue: [^right-1] ifFalse: [^right]! !

!S2QuicksortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 16:40:47.626'!
nextFirstFocusedIndex: currentIndex
	^currentIndex + 1! !

!S2QuicksortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 16:40:54.041'!
nextSecondFocusedIndex: currentIndex
	^currentIndex - 1! !

!S2QuicksortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 19:39:22.148'!
shouldUpdateFirst: element withPivot: pivot
	^element <= pivot.! !

!S2QuicksortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 16:44:11.82'!
shouldUpdateSecond: element withPivot: pivot
	^element >= pivot.! !

!S2QuicksortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 16:41:51.576'!
updateBothFocusesAtOnce
	^false! !

Object subclass: #S2AbstractIterator
	instanceVariableNames: 'sorter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2AbstractIterator class methodsFor: 'as yet unclassified' stamp: 'AT 6/11/2013 18:04:11.464'!
newWithSorter: aSorter
|me|
	me := self new.
	me sorter: aSorter.
	^me.! !

!S2AbstractIterator methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 00:56:07.24'!
abortFocusingInList: list
	^self subclassResponsibility.! !

!S2AbstractIterator methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 00:57:57.962'!
nextFocusedIndicesIteration
|list|
	list := self sorter list.
	^list firstFocusedIndex isNil or: [list secondFocusedIndex isNil] or: [(self abortFocusingInList: list) not]! !

!S2AbstractIterator methodsFor: 'as yet unclassified' stamp: 'AT 6/11/2013 18:02:43.528'!
nextListPartIteration
	^(self sorter list elements size = self sorter list sortedIndices size) not! !

!S2AbstractIterator methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:29:45.465'!
sorter

	^ sorter! !

!S2AbstractIterator methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:29:45.48'!
sorter: anObject

	sorter := anObject! !

S2AbstractIterator subclass: #S2BubblesortIterator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2BubblesortIterator methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 09:57:40.796'!
abortFocusingInList: list
	(list sortedIndices size > 0) 
		ifTrue: [^list secondFocusedIndex >= list sortedIndices first]
		ifFalse: [^list secondFocusedIndex > list elements size]! !

S2AbstractIterator subclass: #S2QuicksortIterator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2QuicksortIterator methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 00:54:28.156'!
abortFocusingInList: list
	^list firstFocusedIndex >= list secondFocusedIndex.! !

Object subclass: #S2AbstractListPartFinder
	instanceVariableNames: 'sorter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2AbstractListPartFinder class methodsFor: 'as yet unclassified' stamp: 'AT 6/11/2013 18:04:18.423'!
newWithSorter: aSorter
|me|
	me := self new.
	me sorter: aSorter.
	^me.! !

!S2AbstractListPartFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 17:05:17.027'!
findLeftIndex
	^self findLeftIndexInListWithLength: (self sorter list elements size) 
		withSortedIndices: (self sorter list sortedIndices).! !

!S2AbstractListPartFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 17:05:45.562'!
findLeftIndexInListWithLength: l withSortedIndices: sorted
	^self subclassResponsibility.! !

!S2AbstractListPartFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 17:05:11.867'!
findRightIndex
	^self findRightIndexInListWithLength: (self sorter list elements size) 
		withSortedIndices: (self sorter list sortedIndices).! !

!S2AbstractListPartFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 17:05:56.105'!
findRightIndexInListWithLength: l withSortedIndices: sorted
	^self subclassResponsibility.! !

!S2AbstractListPartFinder methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:29:29.794'!
sorter

	^ sorter! !

!S2AbstractListPartFinder methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:29:29.81'!
sorter: anObject

	sorter := anObject! !

!S2AbstractListPartFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 09:47:17.464'!
updateListPartIndices
	self sorter list updateLeftBoundaryIndex: self findLeftIndex.
	self sorter list updateRightBoundaryIndex: self findRightIndex.! !

S2AbstractListPartFinder subclass: #S2BubblesortListPartFinder
	instanceVariableNames: 'left'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2BubblesortListPartFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 00:23:46.972'!
findLeftIndexInListWithLength: l withSortedIndices: sorted
	"Finds the first index that is not sorted yet"
	^1! !

!S2BubblesortListPartFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 10:30:57.345'!
findRightIndexInListWithLength: l withSortedIndices: sorted
	sorted size > 0 ifTrue: [^sorted first - 1] ifFalse: [^l]! !

S2AbstractListPartFinder subclass: #S2QuicksortListPartFinder
	instanceVariableNames: 'left'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2QuicksortListPartFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 10:56:27.903'!
findLeftIndexInListWithLength: l withSortedIndices: sorted
	"Finds the first index that is not sorted yet"
	^(1 to: l) detect: [:ea | (sorted includes: ea) not] ifNone: [nil].! !

!S2QuicksortListPartFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 11:50:57.763'!
findRightIndexInListWithLength: l withSortedIndices: sorted
	^(1 to: l) detect: [:ea | 
		(sorted includes: (ea)) not and: ((sorted includes: ea + 1) or: (ea = l)).
	] ifNone: [nil].! !

Object subclass: #S2AbstractListPartSorter
	instanceVariableNames: 'sorter focusedIndexFinder focusedIndexEvaluator iterator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2AbstractListPartSorter class methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 14:42:22.564'!
newWithSorter: aSorter
|me|
	me := self new.
	me sorter: aSorter.
	me iterator: aSorter iterator.
	^me.! !

!S2AbstractListPartSorter methodsFor: 'accessing' stamp: 'AT 6/16/2013 14:40:32.342'!
focusedIndexEvaluator

	^ focusedIndexEvaluator! !

!S2AbstractListPartSorter methodsFor: 'accessing' stamp: 'AT 6/16/2013 14:40:32.353'!
focusedIndexEvaluator: anObject

	focusedIndexEvaluator := anObject! !

!S2AbstractListPartSorter methodsFor: 'accessing' stamp: 'AT 6/16/2013 14:40:32.312'!
focusedIndexFinder

	^ focusedIndexFinder! !

!S2AbstractListPartSorter methodsFor: 'accessing' stamp: 'AT 6/16/2013 14:40:32.328'!
focusedIndexFinder: anObject

	focusedIndexFinder := anObject! !

!S2AbstractListPartSorter methodsFor: 'initialization' stamp: 'AT 6/17/2013 01:13:05.112'!
initialize
	super initialize.! !

!S2AbstractListPartSorter methodsFor: 'accessing' stamp: 'AT 6/16/2013 14:40:32.371'!
iterator

	^ iterator! !

!S2AbstractListPartSorter methodsFor: 'accessing' stamp: 'AT 6/16/2013 14:40:32.383'!
iterator: anObject

	iterator := anObject! !

!S2AbstractListPartSorter methodsFor: 'initialization' stamp: 'AT 6/16/2013 17:01:02.937'!
resetFocusedIndicesInList: list
	list updateFirstFocusedIndex: nil.
	list updateSecondFocusedIndex: nil.
	list updatePivotIndex: nil.! !

!S2AbstractListPartSorter methodsFor: 'sorting' stamp: 'AT 6/17/2013 09:59:33.212'!
sortListPart
|list|
	list := self sorter list.
	"imitiating do-while loop"
	self focusedIndexFinder updateFocusedElementsIndices.
	[ self iterator nextFocusedIndicesIteration ] whileTrue:
		[ self focusedIndexEvaluator evaluateFocusedElements.
		self focusedIndexFinder updateFocusedElementsIndices. ].
	self updatePivotPositionInList: list.
	self updateSortedIndicesInList: list.
	self resetFocusedIndicesInList: list.! !

!S2AbstractListPartSorter methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:29:36.684'!
sorter

	^ sorter! !

!S2AbstractListPartSorter methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:29:36.7'!
sorter: anObject

	sorter := anObject! !

!S2AbstractListPartSorter methodsFor: 'sorting' stamp: 'AT 6/16/2013 17:27:21.744'!
updatePivotPositionInList: list
	^self subclassResponsibility.! !

!S2AbstractListPartSorter methodsFor: 'sorting' stamp: 'AT 6/16/2013 17:52:43.013'!
updateSortedIndicesInList: list
	^self subclassResponsibility.! !

S2AbstractListPartSorter subclass: #S2BubblesortListPartSorter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2BubblesortListPartSorter methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 00:46:20.505'!
initialize
	super initialize.
	self focusedIndexFinder: (S2BubblesortFocusedIndicesFinder newWithListPartSorter: self).
	self focusedIndexEvaluator: (S2BubblesortFocusedIndicesEvaluator newWithListPartSorter: self).
	self iterator: (S2BubblesortIterator newWithSorter: self).! !

!S2BubblesortListPartSorter methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 00:22:36.052'!
updatePivotPositionInList: list.
! !

!S2BubblesortListPartSorter methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 09:43:09.83'!
updateSortedIndicesInList: list
	list addIndexAsSorted: list firstFocusedIndex.! !

S2AbstractListPartSorter subclass: #S2QuicksortListPartSorter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2QuicksortListPartSorter methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 00:46:08.278'!
initialize
	super initialize.
	self focusedIndexFinder: (S2QuicksortFocusedIndicesFinder newWithListPartSorter: self).
	self focusedIndexEvaluator: (S2QuicksortFocusedIndicesEvaluator newWithListPartSorter: self).
	self iterator: (S2QuicksortIterator newWithSorter: self).! !

!S2QuicksortListPartSorter methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 18:41:51.825'!
updatePivotPositionInList: list.
	list pivotElement > list firstFocusedElement
	ifTrue: [list insertPivotAt: (list firstFocusedIndex + 1)]
	ifFalse: [list insertPivotAt: (list firstFocusedIndex)]! !

!S2QuicksortListPartSorter methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 17:52:29.638'!
updateSortedIndicesInList: list
	list addIndexAsSorted: list pivotIndex.! !

Object subclass: #S2AbstractSorter
	instanceVariableNames: 'list iterator listPartFinder listPartSorter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2AbstractSorter class methodsFor: 'as yet unclassified' stamp: 'AT 6/11/2013 17:38:57.102'!
newWithList: anObject
|me|
	me := self new.
	me setupList: anObject.
	^me.! !

!S2AbstractSorter methodsFor: 'setup' stamp: 'AT 6/16/2013 17:09:15.602'!
initialLeftBoundIndexWithinElements: elements
	^self subclassResponsibility.! !

!S2AbstractSorter methodsFor: 'setup' stamp: 'AT 6/16/2013 17:09:23.32'!
initialRightBoundIndexWithinElements: elements
	^self subclassResponsibility.! !

!S2AbstractSorter methodsFor: 'setup' stamp: 'AT 6/16/2013 17:09:03.264'!
initializeBoundariesInList: list
	list leftBoundIndex: (self initialLeftBoundIndexWithinElements: list elements).
	list rightBoundIndex: (self initialRightBoundIndexWithinElements: list elements).! !

!S2AbstractSorter methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:03:44.445'!
iterator

	^ iterator! !

!S2AbstractSorter methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:03:44.458'!
iterator: anObject

	iterator := anObject! !

!S2AbstractSorter methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:03:44.416'!
list

	^ list! !

!S2AbstractSorter methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:42:16.782'!
list: anObject
	list := S2List new.
	list setupList: anObject.! !

!S2AbstractSorter methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:03:44.476'!
listPartFinder

	^ listPartFinder! !

!S2AbstractSorter methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:03:44.489'!
listPartFinder: anObject

	listPartFinder := anObject! !

!S2AbstractSorter methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:03:44.5'!
listPartSorter

	^ listPartSorter! !

!S2AbstractSorter methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:03:44.511'!
listPartSorter: anObject

	listPartSorter := anObject! !

!S2AbstractSorter methodsFor: 'setup' stamp: 'AT 6/16/2013 18:09:57.11'!
setupList: anObject
	self list: anObject asOrderedCollection.
	"self initializeBoundariesInList: self list"! !

!S2AbstractSorter methodsFor: 'sorting' stamp: 'AT 6/17/2013 09:51:52.652'!
sort
	Transcript clear.
	Transcript show: self list elements asString, String cr.
	[ self iterator nextListPartIteration ] whileTrue: 
		[ self listPartFinder updateListPartIndices.
		self listPartSorter sortListPart.].! !

S2AbstractSorter subclass: #S2Bubblesort
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

S2AbstractSorter subclass: #S2Bubblesorter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2Bubblesorter methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 01:14:43.63'!
initialize
	super initialize.
	self iterator: (S2BubblesortIterator newWithSorter: self).
	self listPartFinder: (S2BubblesortListPartFinder newWithSorter: self).
	self listPartSorter: (S2BubblesortListPartSorter newWithSorter: self).! !

S2AbstractSorter subclass: #S2Quicksorter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2Quicksorter methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 00:56:52.976'!
initialize
	super initialize.
	self iterator: (S2QuicksortIterator newWithSorter: self).
	self listPartFinder: (S2QuicksortListPartFinder newWithSorter: self).
	self listPartSorter: (S2QuicksortListPartSorter newWithSorter: self).! !

Object subclass: #S2List
	instanceVariableNames: 'sortedIndices elements leftBoundIndex rightBoundIndex firstFocusedIndex secondFocusedIndex pivotIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2List methodsFor: 'updating' stamp: 'AT 6/17/2013 09:52:18.064'!
addIndexAsSorted: idx
	Transcript show:'Sorted: ',idx asString, String cr.
	self sortedIndices add: idx.
	Transcript show: self elements asString, String cr.! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:01:33.217'!
elements

	^ elements! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 15:51:40.812'!
elements: anObject

	elements := anObject.! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/17/2013 10:14:22.772'!
firstFocusedElement
	(self firstFocusedIndex isNil or: [self firstFocusedIndex > self elements size]) ifTrue: [^nil].
	^ self elements at: self firstFocusedIndex.! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 16:26:46.685'!
firstFocusedIndex

	^ firstFocusedIndex! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 16:26:46.759'!
firstFocusedIndex: anObject

	firstFocusedIndex := anObject! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 17:54:25.108'!
initialize
	super initialize.
	self elements: #() asOrderedCollection;
		sortedIndices: #() asSortedCollection.! !

!S2List methodsFor: 'updating' stamp: 'JB 6/17/2013 15:55:13.658'!
insertPivotAt: p
|templeft tempmiddle tempright copy|
	Transcript show:'Moving Pivot from ',self pivotIndex asString, ' to ', p asString, String cr.
	copy := self elements copy.
	(self pivotIndex > p) 
		ifTrue: [templeft := self elements copyFrom: 1 to: p-1.
			tempmiddle := self elements copyFrom: p to: self pivotIndex-1.
			tempright := self elements copyFrom: (self pivotIndex + 1) to: self elements size.
			self elements: templeft, self pivotElement asOrderedCollection,tempmiddle, tempright.].
	(self pivotIndex < p) ifTrue: [templeft := self elements copyFrom: 1 to: self pivotIndex -1.
			tempmiddle := self elements copyFrom: (self pivotIndex + 1) to: p-1.
			tempright := self elements copyFrom: p to: self elements size.
			self elements: templeft,tempmiddle,self pivotElement asOrderedCollection, tempright.].
	self updatePivotIndex: p.
	Transcript show: self elements asString, String cr.
	! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 15:29:20.305'!
leftBoundIndex

	^ leftBoundIndex! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 15:29:20.319'!
leftBoundIndex: anObject

	leftBoundIndex := anObject! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/17/2013 10:12:41.195'!
pivotElement
	(self pivotIndex isNil or: [self pivotIndex > self elements size]) ifTrue: [^nil].
	^ self elements at: self pivotIndex.! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 16:26:46.804'!
pivotIndex

	^ pivotIndex! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 16:26:46.817'!
pivotIndex: anObject

	pivotIndex := anObject! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 15:29:20.331'!
rightBoundIndex

	^ rightBoundIndex! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 15:29:20.345'!
rightBoundIndex: anObject

	rightBoundIndex := anObject! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/17/2013 10:14:28.961'!
secondFocusedElement
	(self secondFocusedIndex isNil or: [self secondFocusedIndex > self elements size]) ifTrue: [^nil].
	^ self elements at: self secondFocusedIndex.! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 16:26:46.775'!
secondFocusedIndex

	^ secondFocusedIndex! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 16:26:46.79'!
secondFocusedIndex: anObject

	secondFocusedIndex := anObject! !

!S2List methodsFor: 'initialization' stamp: 'AT 6/16/2013 18:05:17.919'!
setupList: anObject
	self elements: anObject asOrderedCollection.! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 15:51:09.23'!
sortedIndices

	^ sortedIndices! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 15:51:09.248'!
sortedIndices: anObject

	sortedIndices := anObject! !

!S2List methodsFor: 'updating' stamp: 'AT 6/17/2013 09:52:39.637'!
switchElementAt: i withElementAt: j
|temp|
	Transcript show:'Switching element at ',i asString, ' with ', j asString, String cr.
	temp := self elements at: i.
	self elements at: i put: (self elements at: j).
	self elements at: j put: temp.
	Transcript show: self elements asString, String cr.! !

!S2List methodsFor: 'updating' stamp: 'AT 6/17/2013 10:26:37.855'!
updateFirstFocusedIndex: idx
	Transcript show:'First focus: ',idx asString, String cr.
	self firstFocusedIndex: idx.! !

!S2List methodsFor: 'updating' stamp: 'AT 6/17/2013 10:26:46.295'!
updateLeftBoundaryIndex: idx
	Transcript show:'Left bound: ',idx asString, String cr.
	self leftBoundIndex: idx.! !

!S2List methodsFor: 'updating' stamp: 'AT 6/17/2013 10:26:56.012'!
updatePivotIndex: idx
	Transcript show:'Pivot: ',idx asString, String cr.
	self pivotIndex: idx.! !

!S2List methodsFor: 'updating' stamp: 'AT 6/17/2013 10:29:52.749'!
updateRightBoundaryIndex: idx
	Transcript show:'Right bound: ',idx asString, String cr.
	self rightBoundIndex: idx.! !

!S2List methodsFor: 'updating' stamp: 'AT 6/17/2013 10:27:18.889'!
updateSecondFocusedIndex: idx
	Transcript show:'Second Focus: ',idx asString, String cr.
	self secondFocusedIndex: idx.! !
